{-# OPTIONS -fglasgow-exts -cpp #-}
module ParserCore ( parseCore ) where

import IfaceSyn
import ForeignCall
import RdrHsSyn
import HsSyn
import RdrName
import OccName
import Kind( Kind(..) )
import Name( nameOccName, nameModule )
import Module
import ParserCoreUtils
import LexCore
import Literal
import SrcLoc
import TysPrim( wordPrimTyCon, intPrimTyCon, charPrimTyCon, 
		floatPrimTyCon, doublePrimTyCon, addrPrimTyCon )
import TyCon ( TyCon, tyConName )
import FastString
import Outputable
import Char

#include "../HsVersions.h"
import Array
#if __GLASGOW_HASKELL__ >= 503
import GHC.Exts
#else
import GlaExts
#endif

-- parser produced by Happy Version 1.15

newtype HappyAbsSyn  = HappyAbsSyn (() -> ())
happyIn4 :: (HsExtCore RdrName) -> (HappyAbsSyn )
happyIn4 x = unsafeCoerce# x
{-# INLINE happyIn4 #-}
happyOut4 :: (HappyAbsSyn ) -> (HsExtCore RdrName)
happyOut4 x = unsafeCoerce# x
{-# INLINE happyOut4 #-}
happyIn5 :: (Module) -> (HappyAbsSyn )
happyIn5 x = unsafeCoerce# x
{-# INLINE happyIn5 #-}
happyOut5 :: (HappyAbsSyn ) -> (Module)
happyOut5 x = unsafeCoerce# x
{-# INLINE happyOut5 #-}
happyIn6 :: ([TyClDecl RdrName]) -> (HappyAbsSyn )
happyIn6 x = unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn ) -> ([TyClDecl RdrName])
happyOut6 x = unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: (TyClDecl RdrName) -> (HappyAbsSyn )
happyIn7 x = unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn ) -> (TyClDecl RdrName)
happyOut7 x = unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: (OccName -> [LConDecl RdrName]) -> (HappyAbsSyn )
happyIn8 x = unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn ) -> (OccName -> [LConDecl RdrName])
happyOut8 x = unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: ([LConDecl RdrName]) -> (HappyAbsSyn )
happyIn9 x = unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn ) -> ([LConDecl RdrName])
happyOut9 x = unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: (LConDecl RdrName) -> (HappyAbsSyn )
happyIn10 x = unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn ) -> (LConDecl RdrName)
happyOut10 x = unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: ([LHsTyVarBndr RdrName]) -> (HappyAbsSyn )
happyIn11 x = unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn ) -> ([LHsTyVarBndr RdrName])
happyOut11 x = unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: ([LHsType RdrName]) -> (HappyAbsSyn )
happyIn12 x = unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn ) -> ([LHsType RdrName])
happyOut12 x = unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: ([IfaceType]) -> (HappyAbsSyn )
happyIn13 x = unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn ) -> ([IfaceType])
happyOut13 x = unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: (IfaceType) -> (HappyAbsSyn )
happyIn14 x = unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn ) -> (IfaceType)
happyOut14 x = unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: (IfaceType) -> (HappyAbsSyn )
happyIn15 x = unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn ) -> (IfaceType)
happyOut15 x = unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: (IfaceType) -> (HappyAbsSyn )
happyIn16 x = unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn ) -> (IfaceType)
happyOut16 x = unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: ([IfaceBinding]) -> (HappyAbsSyn )
happyIn17 x = unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn ) -> ([IfaceBinding])
happyOut17 x = unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: (IfaceBinding) -> (HappyAbsSyn )
happyIn18 x = unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn ) -> (IfaceBinding)
happyOut18 x = unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: ([(IfaceIdBndr, IfaceExpr)]) -> (HappyAbsSyn )
happyIn19 x = unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn ) -> ([(IfaceIdBndr, IfaceExpr)])
happyOut19 x = unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: ((IfaceIdBndr, IfaceExpr)) -> (HappyAbsSyn )
happyIn20 x = unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn ) -> ((IfaceIdBndr, IfaceExpr))
happyOut20 x = unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: (OccName) -> (HappyAbsSyn )
happyIn21 x = unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn ) -> (OccName)
happyOut21 x = unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: (IfaceBndr) -> (HappyAbsSyn )
happyIn22 x = unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn ) -> (IfaceBndr)
happyOut22 x = unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: ([IfaceBndr]) -> (HappyAbsSyn )
happyIn23 x = unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn ) -> ([IfaceBndr])
happyOut23 x = unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: (IfaceIdBndr) -> (HappyAbsSyn )
happyIn24 x = unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn ) -> (IfaceIdBndr)
happyOut24 x = unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: ([IfaceIdBndr]) -> (HappyAbsSyn )
happyIn25 x = unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn ) -> ([IfaceIdBndr])
happyOut25 x = unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: (IfaceTvBndr) -> (HappyAbsSyn )
happyIn26 x = unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn ) -> (IfaceTvBndr)
happyOut26 x = unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: ([IfaceTvBndr]) -> (HappyAbsSyn )
happyIn27 x = unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn ) -> ([IfaceTvBndr])
happyOut27 x = unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: (IfaceKind) -> (HappyAbsSyn )
happyIn28 x = unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn ) -> (IfaceKind)
happyOut28 x = unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: (IfaceKind) -> (HappyAbsSyn )
happyIn29 x = unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn ) -> (IfaceKind)
happyOut29 x = unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: (IfaceExpr) -> (HappyAbsSyn )
happyIn30 x = unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn ) -> (IfaceExpr)
happyOut30 x = unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyIn31 :: (IfaceExpr) -> (HappyAbsSyn )
happyIn31 x = unsafeCoerce# x
{-# INLINE happyIn31 #-}
happyOut31 :: (HappyAbsSyn ) -> (IfaceExpr)
happyOut31 x = unsafeCoerce# x
{-# INLINE happyOut31 #-}
happyIn32 :: (IfaceExpr) -> (HappyAbsSyn )
happyIn32 x = unsafeCoerce# x
{-# INLINE happyIn32 #-}
happyOut32 :: (HappyAbsSyn ) -> (IfaceExpr)
happyOut32 x = unsafeCoerce# x
{-# INLINE happyOut32 #-}
happyIn33 :: ([IfaceAlt]) -> (HappyAbsSyn )
happyIn33 x = unsafeCoerce# x
{-# INLINE happyIn33 #-}
happyOut33 :: (HappyAbsSyn ) -> ([IfaceAlt])
happyOut33 x = unsafeCoerce# x
{-# INLINE happyOut33 #-}
happyIn34 :: (IfaceAlt) -> (HappyAbsSyn )
happyIn34 x = unsafeCoerce# x
{-# INLINE happyIn34 #-}
happyOut34 :: (HappyAbsSyn ) -> (IfaceAlt)
happyOut34 x = unsafeCoerce# x
{-# INLINE happyOut34 #-}
happyIn35 :: (Literal) -> (HappyAbsSyn )
happyIn35 x = unsafeCoerce# x
{-# INLINE happyIn35 #-}
happyOut35 :: (HappyAbsSyn ) -> (Literal)
happyOut35 x = unsafeCoerce# x
{-# INLINE happyOut35 #-}
happyIn36 :: (OccName) -> (HappyAbsSyn )
happyIn36 x = unsafeCoerce# x
{-# INLINE happyIn36 #-}
happyOut36 :: (HappyAbsSyn ) -> (OccName)
happyOut36 x = unsafeCoerce# x
{-# INLINE happyOut36 #-}
happyIn37 :: (OccName) -> (HappyAbsSyn )
happyIn37 x = unsafeCoerce# x
{-# INLINE happyIn37 #-}
happyOut37 :: (HappyAbsSyn ) -> (OccName)
happyOut37 x = unsafeCoerce# x
{-# INLINE happyOut37 #-}
happyIn38 :: (IfaceExtName) -> (HappyAbsSyn )
happyIn38 x = unsafeCoerce# x
{-# INLINE happyIn38 #-}
happyOut38 :: (HappyAbsSyn ) -> (IfaceExtName)
happyOut38 x = unsafeCoerce# x
{-# INLINE happyOut38 #-}
happyIn39 :: (OccName) -> (HappyAbsSyn )
happyIn39 x = unsafeCoerce# x
{-# INLINE happyIn39 #-}
happyOut39 :: (HappyAbsSyn ) -> (OccName)
happyOut39 x = unsafeCoerce# x
{-# INLINE happyOut39 #-}
happyIn40 :: (OccName) -> (HappyAbsSyn )
happyIn40 x = unsafeCoerce# x
{-# INLINE happyIn40 #-}
happyOut40 :: (HappyAbsSyn ) -> (OccName)
happyOut40 x = unsafeCoerce# x
{-# INLINE happyOut40 #-}
happyInTok :: Token -> (HappyAbsSyn )
happyInTok x = unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn ) -> Token
happyOutTok x = unsafeCoerce# x
{-# INLINE happyOutTok #-}

happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x5c\x01\x5c\x01\x53\x01\x52\x01\x4c\x01\x00\x00\xbc\x00\x51\x01\x47\x01\x47\x01\x50\x01\x10\x00\x10\x00\x4c\x01\x00\x00\x48\x01\x00\x00\x4e\x01\x00\x00\x00\x00\x4f\x01\x00\x00\x00\x00\x06\x01\x25\x00\xbc\x00\x00\x00\x10\x00\x4d\x01\x00\x00\x40\x01\x00\x00\x4b\x01\x3e\x01\x00\x00\x00\x00\x25\x00\x46\x01\x49\x01\x00\x00\x00\x00\x42\x01\x44\x01\x13\x01\x13\x01\x10\x00\x45\x01\x3a\x01\x06\x01\x00\x00\x3b\x01\x00\x00\x13\x01\x00\x00\x00\x00\x25\x00\x00\x00\xf4\x00\x25\x00\x36\x01\x20\x01\x00\x00\x43\x01\x20\x01\x00\x00\x00\x00\x00\x00\x3f\x01\x04\x01\x7c\x00\x00\x00\x00\x00\x38\x01\x00\x00\x0d\x01\x00\x00\x00\x00\x00\x00\xbc\x00\x2b\x01\x13\x01\x16\x01\x11\x01\xd8\x00\x66\x00\x17\x01\x00\x00\x25\x00\x00\x00\x00\x00\x00\x00\x66\x00\xff\x00\x00\x00\xeb\x00\x10\x00\x0b\x01\xef\x00\xe9\x00\xdf\x00\xd6\x00\x13\x01\xf4\x00\xf4\x00\x25\x00\xda\x00\x00\x00\x13\x01\x06\x01\x13\x01\x25\x00\x10\x00\xca\x00\x00\x00\xc9\x00\xce\x00\x00\x00\x00\x00\x20\x01\x00\x00\xb9\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf4\x00\xc7\x00\x00\x00\x00\x00\x00\x00\x13\x01\x13\x01\x13\x01\x13\x01\x00\x00\x00\x00\xb8\x00\xf4\x00\x00\x00\x00\x00\x25\x00\xc4\x00\xbb\x00\xb0\x00\xa6\x00\x10\x01\x00\x00\x00\x00\x00\x00\xa7\x00\x00\x00\x00\x00\x00\x00\x00\x00\x98\x00\x00\x00\x90\x00\x9e\x00\xde\x00\x93\x00\x8a\x00\x77\x00\x8f\x00\x8d\x00\x24\x01\xf4\x00\xf4\x00\xde\x00\x00\x00\x6e\x00\x66\x00\x00\x00\x00\x00\x00\x00\x83\x00\xf4\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x76\x00\x00\x00\x88\x00\x00\x00\x4a\x01\x00\x00\xf8\x00\x00\x00\x06\x00\x04\x00\x00\x00\x21\x01\x1d\x01\x39\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x01\x3b\x00\xe0\x00\x00\x00\xd2\x00\x00\x00\x00\x00\x61\x00\x00\x00\x75\x00\x00\x00\x00\x00\x00\x00\x38\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x34\x00\x31\x00\xa3\x00\x00\x00\x00\x00\x03\x01\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x00\x00\x14\x00\x00\x00\xb3\x00\x11\x00\xc2\x00\x3a\x00\x00\x00\x00\x00\xf6\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x46\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb6\x00\x00\x00\x00\x00\x00\x00\xfc\x00\x00\x00\x65\x00\x00\x00\x00\x00\xaa\x00\x37\x01\x00\x00\x00\x00\x0e\x00\x00\x00\x00\x00\x00\x00\x34\x01\x00\x00\x00\x00\x29\x00\x4e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x62\x00\xa1\x00\x97\x00\x0b\x00\x00\x00\x00\x00\x5b\x00\xf7\xff\x01\x00\x05\x00\x2f\x00\x7a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfb\xff\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x8e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x58\x00\x4b\x00\x3f\x00\x3e\x00\x00\x00\x00\x00\x00\x00\x85\x00\x00\x00\x00\x00\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x69\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf0\xff\x00\x00\xbd\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7b\x00\x72\x00\x4a\x00\x00\x00\xde\xff\x2c\x01\x00\x00\x00\x00\x00\x00\x00\x00\x56\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\x00\x00\x00\x00\x00\x00\xfc\xff\xfd\xff\xe5\xff\x00\x00\x00\x00\x00\x00\x00\x00\xd3\xff\xd3\xff\xfc\xff\xfe\xff\x00\x00\xe2\xff\x00\x00\xde\xff\xdd\xff\x00\x00\xb3\xff\xb0\xff\x00\x00\x00\x00\xe5\xff\xfb\xff\xd3\xff\x00\x00\xd5\xff\x00\x00\xb4\xff\xf8\xff\x00\x00\xb2\xff\xf9\xff\x00\x00\x00\x00\x00\x00\xd2\xff\xe4\xff\xe8\xff\x00\x00\xef\xff\xef\xff\xd3\xff\x00\x00\xe1\xff\x00\x00\xe3\xff\x00\x00\xe9\xff\xef\xff\xed\xff\xec\xff\x00\x00\xea\xff\x00\x00\x00\x00\x00\x00\x00\x00\xf7\xff\x00\x00\x00\x00\xd0\xff\xd1\xff\xcf\xff\x00\x00\xf6\xff\xf2\xff\xb1\xff\xe7\xff\x00\x00\xc5\xff\xc4\xff\xdf\xff\xc9\xff\xcb\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xee\xff\x00\x00\xe0\xff\xe6\xff\xeb\xff\xda\xff\x00\x00\xdb\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc7\xff\x00\x00\x00\x00\xef\xff\x00\x00\x00\x00\x00\x00\xfa\xff\xcd\xff\x00\x00\xd4\xff\xce\xff\x00\x00\xf5\xff\xf2\xff\xf3\xff\xf4\xff\xf0\xff\xca\xff\xc6\xff\x00\x00\x00\x00\xc0\xff\xbf\xff\xbe\xff\x00\x00\x00\x00\x00\x00\x00\x00\xc8\xff\xdc\xff\x00\x00\x00\x00\xd9\xff\xc3\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc2\xff\xf1\xff\xcc\xff\x00\x00\xb6\xff\xb5\xff\xb7\xff\xb8\xff\x00\x00\xd8\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbd\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc1\xff\x00\x00\x00\x00\xbc\xff\xba\xff\xb9\xff\x00\x00\x00\x00\xbb\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x23\x00\x01\x00\x01\x00\x14\x00\x01\x00\x01\x00\x01\x00\x11\x00\x08\x00\x09\x00\x0a\x00\x01\x00\x0b\x00\x0c\x00\x01\x00\x0b\x00\x0c\x00\x01\x00\x18\x00\x19\x00\x01\x00\x0b\x00\x0c\x00\x21\x00\x0b\x00\x0c\x00\x24\x00\x0b\x00\x0c\x00\x0e\x00\x0b\x00\x0c\x00\x20\x00\x20\x00\x22\x00\x22\x00\x20\x00\x22\x00\x22\x00\x22\x00\x04\x00\x07\x00\x20\x00\x1c\x00\x22\x00\x20\x00\x01\x00\x22\x00\x20\x00\x01\x00\x22\x00\x20\x00\x01\x00\x22\x00\x09\x00\x0a\x00\x01\x00\x09\x00\x0a\x00\x01\x00\x09\x00\x0a\x00\x01\x00\x01\x00\x1c\x00\x1d\x00\x0b\x00\x0c\x00\x16\x00\x0b\x00\x0c\x00\x0a\x00\x0a\x00\x21\x00\x01\x00\x01\x00\x07\x00\x20\x00\x20\x00\x22\x00\x20\x00\x18\x00\x22\x00\x20\x00\x0a\x00\x22\x00\x01\x00\x20\x00\x01\x00\x22\x00\x20\x00\x01\x00\x22\x00\x20\x00\x20\x00\x22\x00\x22\x00\x0a\x00\x01\x00\x16\x00\x0a\x00\x01\x00\x1d\x00\x1e\x00\x1f\x00\x01\x00\x20\x00\x0a\x00\x22\x00\x20\x00\x0a\x00\x1a\x00\x1b\x00\x1c\x00\x01\x00\x0e\x00\x1f\x00\x00\x00\x21\x00\x20\x00\x04\x00\x22\x00\x20\x00\x01\x00\x22\x00\x18\x00\x05\x00\x06\x00\x20\x00\x20\x00\x1a\x00\x22\x00\x20\x00\x01\x00\x22\x00\x1f\x00\x01\x00\x21\x00\x1d\x00\x1a\x00\x1b\x00\x1c\x00\x01\x00\x14\x00\x1f\x00\x1b\x00\x21\x00\x18\x00\x1a\x00\x1b\x00\x1c\x00\x01\x00\x16\x00\x1f\x00\x11\x00\x21\x00\x23\x00\x0e\x00\x1a\x00\x1b\x00\x1c\x00\x01\x00\x16\x00\x1f\x00\x16\x00\x21\x00\x0f\x00\x1a\x00\x1b\x00\x1c\x00\x01\x00\x19\x00\x1f\x00\x10\x00\x21\x00\x09\x00\x1a\x00\x1b\x00\x1c\x00\x01\x00\x0f\x00\x1f\x00\x01\x00\x21\x00\x16\x00\x17\x00\x1a\x00\x1b\x00\x1c\x00\x01\x00\x0f\x00\x1f\x00\x05\x00\x21\x00\x20\x00\x1a\x00\x1b\x00\x1c\x00\x05\x00\x06\x00\x1f\x00\x0f\x00\x21\x00\x14\x00\x1a\x00\x1b\x00\x1c\x00\x1a\x00\x18\x00\x1f\x00\x0f\x00\x21\x00\x1f\x00\x0f\x00\x21\x00\x1c\x00\x1d\x00\x1d\x00\x1e\x00\x1f\x00\x0f\x00\x06\x00\x16\x00\x08\x00\x07\x00\x0a\x00\x0b\x00\x0c\x00\x23\x00\x0e\x00\x1d\x00\x16\x00\x17\x00\x14\x00\x0d\x00\x0e\x00\x0d\x00\x0e\x00\x17\x00\x10\x00\x11\x00\x20\x00\x14\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x06\x00\x1d\x00\x08\x00\x14\x00\x0a\x00\x0b\x00\x0c\x00\x21\x00\x0e\x00\x14\x00\x24\x00\x0d\x00\x0e\x00\x1c\x00\x10\x00\x11\x00\x0e\x00\x17\x00\x10\x00\x11\x00\x18\x00\x19\x00\x1c\x00\x1d\x00\x0f\x00\x10\x00\x11\x00\x16\x00\x0f\x00\x10\x00\x11\x00\x21\x00\x0f\x00\x0e\x00\x24\x00\x21\x00\x0e\x00\x1b\x00\x24\x00\x0e\x00\x1c\x00\x1d\x00\x21\x00\x18\x00\x0f\x00\x24\x00\x21\x00\x1c\x00\x1d\x00\x24\x00\x1c\x00\x1d\x00\x0e\x00\x1c\x00\x1d\x00\x20\x00\x12\x00\x16\x00\x17\x00\x15\x00\x20\x00\x16\x00\x17\x00\x0e\x00\x1a\x00\x02\x00\x03\x00\x20\x00\x12\x00\x13\x00\x14\x00\x20\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x12\x00\x13\x00\x14\x00\x12\x00\x13\x00\x14\x00\x02\x00\x03\x00\x02\x00\x03\x00\x11\x00\x19\x00\x0f\x00\x1d\x00\x19\x00\x1b\x00\x11\x00\x13\x00\x16\x00\x10\x00\x14\x00\x1d\x00\x1c\x00\x01\x00\x13\x00\x10\x00\x13\x00\xff\xff\x14\x00\x1b\x00\x1d\x00\xff\xff\xff\xff\xff\xff\xff\xff\x19\x00\xff\xff\xff\xff\x1b\x00\xff\xff\xff\xff\xff\xff\x1d\x00\xff\xff\xff\xff\xff\xff\x22\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\xab\x00\x0a\x00\x0a\x00\x9e\x00\x0a\x00\x0a\x00\x0a\x00\x7c\x00\x7a\x00\x7b\x00\x34\x00\x0a\x00\x29\x00\x9b\x00\x0a\x00\x29\x00\x79\x00\x0a\x00\x72\x00\x95\x00\x0a\x00\x29\x00\x7f\x00\x12\x00\x29\x00\x59\x00\x13\x00\x29\x00\x47\x00\x1f\x00\x29\x00\x55\x00\x35\x00\x2b\x00\x36\x00\x2c\x00\x2b\x00\x0b\x00\x2c\x00\x0c\x00\x2e\x00\x94\x00\x2b\x00\x20\x00\x2c\x00\x2b\x00\x0a\x00\x2c\x00\x2b\x00\x0a\x00\x2c\x00\x2b\x00\x0a\x00\x2c\x00\x56\x00\x34\x00\x0a\x00\x33\x00\x34\x00\x0a\x00\x38\x00\x34\x00\x0a\x00\x0a\x00\x20\x00\x06\x00\x29\x00\x3d\x00\x78\x00\x29\x00\x2a\x00\x8e\x00\x8f\x00\x89\x00\xa0\x00\x0a\x00\x6d\x00\x35\x00\x1d\x00\x36\x00\x35\x00\x3e\x00\x36\x00\x35\x00\x90\x00\x36\x00\x48\x00\x2b\x00\x0a\x00\x2c\x00\x2b\x00\x0a\x00\x2c\x00\x35\x00\x35\x00\x36\x00\x36\x00\x91\x00\x0a\x00\x88\x00\x7d\x00\x0a\x00\xac\x00\xa2\x00\xa3\x00\x48\x00\x35\x00\x82\x00\x36\x00\x1d\x00\x67\x00\x49\x00\x4a\x00\xb1\x00\x48\x00\x5f\x00\x4c\x00\x03\x00\x4d\x00\x35\x00\x23\x00\x36\x00\x35\x00\x48\x00\x36\x00\x60\x00\x77\x00\x44\x00\x25\x00\x35\x00\x96\x00\x36\x00\x35\x00\x48\x00\x36\x00\x4c\x00\x04\x00\x4d\x00\x47\x00\x49\x00\x4a\x00\xad\x00\x48\x00\x6f\x00\x4c\x00\xa9\x00\x4d\x00\x70\x00\x49\x00\x4a\x00\xae\x00\x48\x00\xb1\x00\x4c\x00\xaa\x00\x4d\x00\x45\x00\x5f\x00\x49\x00\x4a\x00\x8c\x00\x48\x00\xa7\x00\x4c\x00\xa8\x00\x4d\x00\x9d\x00\x49\x00\x4a\x00\x93\x00\x48\x00\xab\x00\x4c\x00\xa0\x00\x4d\x00\x9e\x00\x49\x00\x4a\x00\x80\x00\x48\x00\x98\x00\x4c\x00\x48\x00\x4d\x00\x1b\x00\x32\x00\x49\x00\x4a\x00\x81\x00\xa0\x00\x99\x00\x4c\x00\x15\x00\x4d\x00\x1d\x00\x49\x00\x4a\x00\x60\x00\x43\x00\x44\x00\x4c\x00\x9a\x00\x4d\x00\x8e\x00\x49\x00\x4a\x00\x4b\x00\x6a\x00\x70\x00\x4c\x00\x9b\x00\x4d\x00\x4c\x00\x93\x00\x4d\x00\x16\x00\x17\x00\xa1\x00\xa2\x00\xa3\x00\x76\x00\x4f\x00\x77\x00\x50\x00\x7f\x00\x51\x00\x52\x00\x53\x00\x45\x00\x54\x00\x47\x00\x1b\x00\x27\x00\x84\x00\xa5\x00\xa6\x00\x28\x00\x0f\x00\x55\x00\x10\x00\x11\x00\x1d\x00\x85\x00\x16\x00\x06\x00\x62\x00\x63\x00\x64\x00\x65\x00\x4f\x00\x06\x00\x50\x00\x86\x00\x51\x00\x52\x00\x53\x00\x12\x00\x54\x00\x87\x00\x13\x00\x0e\x00\x0f\x00\x16\x00\x10\x00\x11\x00\x69\x00\x55\x00\x10\x00\x11\x00\x72\x00\x73\x00\x16\x00\x06\x00\x58\x00\x2f\x00\x11\x00\x8b\x00\x2e\x00\x2f\x00\x11\x00\x12\x00\x88\x00\x54\x00\x13\x00\x12\x00\x54\x00\x71\x00\x13\x00\x38\x00\x16\x00\x17\x00\x12\x00\x6c\x00\x5b\x00\x13\x00\x12\x00\x16\x00\x06\x00\x13\x00\x16\x00\x06\x00\x40\x00\x20\x00\x06\x00\x66\x00\x41\x00\x1b\x00\x1c\x00\x42\x00\x67\x00\x1b\x00\x20\x00\x69\x00\x43\x00\x1a\x00\x07\x00\x1d\x00\x5b\x00\xaf\x00\x5d\x00\x1d\x00\x62\x00\x63\x00\x64\x00\x65\x00\x5b\x00\x8b\x00\x5d\x00\x5b\x00\x5c\x00\x5d\x00\x06\x00\x07\x00\x09\x00\x0a\x00\x72\x00\x6d\x00\x75\x00\x47\x00\x58\x00\x31\x00\x32\x00\x3a\x00\x3b\x00\x3c\x00\x3d\x00\x23\x00\x20\x00\x03\x00\x25\x00\x18\x00\x27\x00\x00\x00\x19\x00\x1a\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x00\x00\x0e\x00\x00\x00\x00\x00\x00\x00\x06\x00\x00\x00\x00\x00\x00\x00\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = array (1, 79) [
	(1 , happyReduce_1),
	(2 , happyReduce_2),
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41),
	(42 , happyReduce_42),
	(43 , happyReduce_43),
	(44 , happyReduce_44),
	(45 , happyReduce_45),
	(46 , happyReduce_46),
	(47 , happyReduce_47),
	(48 , happyReduce_48),
	(49 , happyReduce_49),
	(50 , happyReduce_50),
	(51 , happyReduce_51),
	(52 , happyReduce_52),
	(53 , happyReduce_53),
	(54 , happyReduce_54),
	(55 , happyReduce_55),
	(56 , happyReduce_56),
	(57 , happyReduce_57),
	(58 , happyReduce_58),
	(59 , happyReduce_59),
	(60 , happyReduce_60),
	(61 , happyReduce_61),
	(62 , happyReduce_62),
	(63 , happyReduce_63),
	(64 , happyReduce_64),
	(65 , happyReduce_65),
	(66 , happyReduce_66),
	(67 , happyReduce_67),
	(68 , happyReduce_68),
	(69 , happyReduce_69),
	(70 , happyReduce_70),
	(71 , happyReduce_71),
	(72 , happyReduce_72),
	(73 , happyReduce_73),
	(74 , happyReduce_74),
	(75 , happyReduce_75),
	(76 , happyReduce_76),
	(77 , happyReduce_77),
	(78 , happyReduce_78),
	(79 , happyReduce_79)
	]

happy_n_terms = 35 :: Int
happy_n_nonterms = 37 :: Int

happyReduce_1 = happyReduce 4# 0# happyReduction_1
happyReduction_1 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut5 happy_x_2 of { happy_var_2 -> 
	case happyOut6 happy_x_3 of { happy_var_3 -> 
	case happyOut17 happy_x_4 of { happy_var_4 -> 
	happyIn4
		 (HsExtCore happy_var_2 happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_2 = happySpecReduce_1 1# happyReduction_2
happyReduction_2 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TKcname happy_var_1) -> 
	happyIn5
		 (mkSysModuleFS (mkFastString happy_var_1)
	)}

happyReduce_3 = happySpecReduce_0 2# happyReduction_3
happyReduction_3  =  happyIn6
		 ([]
	)

happyReduce_4 = happySpecReduce_3 2# happyReduction_4
happyReduction_4 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	case happyOut6 happy_x_3 of { happy_var_3 -> 
	happyIn6
		 (happy_var_1:happy_var_3
	)}}

happyReduce_5 = happyReduce 7# 3# happyReduction_5
happyReduction_5 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut38 happy_x_2 of { happy_var_2 -> 
	case happyOut27 happy_x_3 of { happy_var_3 -> 
	case happyOut9 happy_x_6 of { happy_var_6 -> 
	happyIn7
		 (mkTyData DataType (noLoc (noLoc [], noLoc (ifaceExtRdrName happy_var_2), map toHsTvBndr happy_var_3)) Nothing happy_var_6 Nothing
	) `HappyStk` happyRest}}}

happyReduce_6 = happyReduce 4# 3# happyReduction_6
happyReduction_6 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut38 happy_x_2 of { happy_var_2 -> 
	case happyOut27 happy_x_3 of { happy_var_3 -> 
	case happyOut8 happy_x_4 of { happy_var_4 -> 
	happyIn7
		 (let tc_rdr = ifaceExtRdrName happy_var_2 in
                  mkTyData NewType (noLoc (noLoc [], noLoc tc_rdr, map toHsTvBndr happy_var_3)) Nothing (happy_var_4 (rdrNameOcc tc_rdr)) Nothing
	) `HappyStk` happyRest}}}

happyReduce_7 = happySpecReduce_0 4# happyReduction_7
happyReduction_7  =  happyIn8
		 ((\ tc_occ -> [])
	)

happyReduce_8 = happySpecReduce_2 4# happyReduction_8
happyReduction_8 happy_x_2
	happy_x_1
	 =  case happyOut16 happy_x_2 of { happy_var_2 -> 
	happyIn8
		 ((\ tc_occ -> let { dc_name  = mkRdrUnqual (setOccNameSpace dataName tc_occ) ;
			                     con_info = PrefixCon [toHsType happy_var_2] }
			                in [noLoc $ ConDecl (noLoc dc_name) []
					   (noLoc []) con_info])
	)}

happyReduce_9 = happySpecReduce_1 5# happyReduction_9
happyReduction_9 happy_x_1
	 =  case happyOut10 happy_x_1 of { happy_var_1 -> 
	happyIn9
		 ([happy_var_1]
	)}

happyReduce_10 = happySpecReduce_3 5# happyReduction_10
happyReduction_10 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut10 happy_x_1 of { happy_var_1 -> 
	case happyOut9 happy_x_3 of { happy_var_3 -> 
	happyIn9
		 (happy_var_1:happy_var_3
	)}}

happyReduce_11 = happySpecReduce_3 6# happyReduction_11
happyReduction_11 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn10
		 (noLoc $ ConDecl (noLoc (mkRdrUnqual happy_var_1)) happy_var_2 (noLoc []) (PrefixCon happy_var_3)
	)}}}

happyReduce_12 = happySpecReduce_3 6# happyReduction_12
happyReduction_12 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_3 of { happy_var_3 -> 
	happyIn10
		 (noLoc $ GadtDecl (noLoc (mkRdrUnqual happy_var_1)) (toHsType happy_var_3)
	)}}

happyReduce_13 = happySpecReduce_0 7# happyReduction_13
happyReduction_13  =  happyIn11
		 ([]
	)

happyReduce_14 = happySpecReduce_3 7# happyReduction_14
happyReduction_14 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut11 happy_x_3 of { happy_var_3 -> 
	happyIn11
		 (toHsTvBndr happy_var_2 : happy_var_3
	)}}

happyReduce_15 = happySpecReduce_1 8# happyReduction_15
happyReduction_15 happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	happyIn12
		 (map toHsType happy_var_1
	)}

happyReduce_16 = happySpecReduce_0 9# happyReduction_16
happyReduction_16  =  happyIn13
		 ([]
	)

happyReduce_17 = happySpecReduce_2 9# happyReduction_17
happyReduction_17 happy_x_2
	happy_x_1
	 =  case happyOut14 happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_2 of { happy_var_2 -> 
	happyIn13
		 (happy_var_1:happy_var_2
	)}}

happyReduce_18 = happySpecReduce_1 10# happyReduction_18
happyReduction_18 happy_x_1
	 =  case happyOut36 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (IfaceTyVar happy_var_1
	)}

happyReduce_19 = happySpecReduce_1 10# happyReduction_19
happyReduction_19 happy_x_1
	 =  case happyOut38 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (IfaceTyConApp (IfaceTc happy_var_1) []
	)}

happyReduce_20 = happySpecReduce_3 10# happyReduction_20
happyReduction_20 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut16 happy_x_2 of { happy_var_2 -> 
	happyIn14
		 (happy_var_2
	)}

happyReduce_21 = happySpecReduce_2 11# happyReduction_21
happyReduction_21 happy_x_2
	happy_x_1
	 =  case happyOut36 happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_2 of { happy_var_2 -> 
	happyIn15
		 (foldl IfaceAppTy (IfaceTyVar happy_var_1) happy_var_2
	)}}

happyReduce_22 = happySpecReduce_2 11# happyReduction_22
happyReduction_22 happy_x_2
	happy_x_1
	 =  case happyOut38 happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_2 of { happy_var_2 -> 
	happyIn15
		 (IfaceTyConApp (IfaceTc happy_var_1) happy_var_2
	)}}

happyReduce_23 = happySpecReduce_1 12# happyReduction_23
happyReduction_23 happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (happy_var_1
	)}

happyReduce_24 = happySpecReduce_3 12# happyReduction_24
happyReduction_24 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_3 of { happy_var_3 -> 
	happyIn16
		 (IfaceFunTy happy_var_1 happy_var_3
	)}}

happyReduce_25 = happyReduce 4# 12# happyReduction_25
happyReduction_25 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut27 happy_x_2 of { happy_var_2 -> 
	case happyOut16 happy_x_4 of { happy_var_4 -> 
	happyIn16
		 (foldr IfaceForAllTy happy_var_4 happy_var_2
	) `HappyStk` happyRest}}

happyReduce_26 = happySpecReduce_0 13# happyReduction_26
happyReduction_26  =  happyIn17
		 ([]
	)

happyReduce_27 = happySpecReduce_3 13# happyReduction_27
happyReduction_27 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut18 happy_x_1 of { happy_var_1 -> 
	case happyOut17 happy_x_3 of { happy_var_3 -> 
	happyIn17
		 (happy_var_1 : happy_var_3
	)}}

happyReduce_28 = happyReduce 4# 14# happyReduction_28
happyReduction_28 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut19 happy_x_3 of { happy_var_3 -> 
	happyIn18
		 (IfaceRec happy_var_3
	) `HappyStk` happyRest}

happyReduce_29 = happySpecReduce_1 14# happyReduction_29
happyReduction_29 happy_x_1
	 =  case happyOut20 happy_x_1 of { happy_var_1 -> 
	happyIn18
		 (let (b,r) = happy_var_1
				  in IfaceNonRec b r
	)}

happyReduce_30 = happySpecReduce_1 15# happyReduction_30
happyReduction_30 happy_x_1
	 =  case happyOut20 happy_x_1 of { happy_var_1 -> 
	happyIn19
		 ([happy_var_1]
	)}

happyReduce_31 = happySpecReduce_3 15# happyReduction_31
happyReduction_31 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut20 happy_x_1 of { happy_var_1 -> 
	case happyOut19 happy_x_3 of { happy_var_3 -> 
	happyIn19
		 (happy_var_1:happy_var_3
	)}}

happyReduce_32 = happyReduce 5# 16# happyReduction_32
happyReduction_32 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut21 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_3 of { happy_var_3 -> 
	case happyOut32 happy_x_5 of { happy_var_5 -> 
	happyIn20
		 (((happy_var_1, happy_var_3), happy_var_5)
	) `HappyStk` happyRest}}}

happyReduce_33 = happySpecReduce_1 17# happyReduction_33
happyReduction_33 happy_x_1
	 =  case happyOut37 happy_x_1 of { happy_var_1 -> 
	happyIn21
		 (happy_var_1
	)}

happyReduce_34 = happySpecReduce_1 17# happyReduction_34
happyReduction_34 happy_x_1
	 =  case happyOut40 happy_x_1 of { happy_var_1 -> 
	happyIn21
		 (happy_var_1
	)}

happyReduce_35 = happySpecReduce_2 18# happyReduction_35
happyReduction_35 happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (IfaceTvBndr happy_var_2
	)}

happyReduce_36 = happySpecReduce_1 18# happyReduction_36
happyReduction_36 happy_x_1
	 =  case happyOut24 happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (IfaceIdBndr happy_var_1
	)}

happyReduce_37 = happySpecReduce_1 19# happyReduction_37
happyReduction_37 happy_x_1
	 =  case happyOut22 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 ([happy_var_1]
	)}

happyReduce_38 = happySpecReduce_2 19# happyReduction_38
happyReduction_38 happy_x_2
	happy_x_1
	 =  case happyOut22 happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_2 of { happy_var_2 -> 
	happyIn23
		 (happy_var_1:happy_var_2
	)}}

happyReduce_39 = happyReduce 5# 20# happyReduction_39
happyReduction_39 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut37 happy_x_2 of { happy_var_2 -> 
	case happyOut16 happy_x_4 of { happy_var_4 -> 
	happyIn24
		 ((happy_var_2,happy_var_4)
	) `HappyStk` happyRest}}

happyReduce_40 = happySpecReduce_0 21# happyReduction_40
happyReduction_40  =  happyIn25
		 ([]
	)

happyReduce_41 = happySpecReduce_2 21# happyReduction_41
happyReduction_41 happy_x_2
	happy_x_1
	 =  case happyOut24 happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn25
		 (happy_var_1:happy_var_2
	)}}

happyReduce_42 = happySpecReduce_1 22# happyReduction_42
happyReduction_42 happy_x_1
	 =  case happyOut36 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 ((happy_var_1, LiftedTypeKind)
	)}

happyReduce_43 = happyReduce 5# 22# happyReduction_43
happyReduction_43 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut36 happy_x_2 of { happy_var_2 -> 
	case happyOut28 happy_x_4 of { happy_var_4 -> 
	happyIn26
		 ((happy_var_2, happy_var_4)
	) `HappyStk` happyRest}}

happyReduce_44 = happySpecReduce_0 23# happyReduction_44
happyReduction_44  =  happyIn27
		 ([]
	)

happyReduce_45 = happySpecReduce_2 23# happyReduction_45
happyReduction_45 happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	case happyOut27 happy_x_2 of { happy_var_2 -> 
	happyIn27
		 (happy_var_1:happy_var_2
	)}}

happyReduce_46 = happySpecReduce_1 24# happyReduction_46
happyReduction_46 happy_x_1
	 =  happyIn28
		 (LiftedTypeKind
	)

happyReduce_47 = happySpecReduce_1 24# happyReduction_47
happyReduction_47 happy_x_1
	 =  happyIn28
		 (UnliftedTypeKind
	)

happyReduce_48 = happySpecReduce_1 24# happyReduction_48
happyReduction_48 happy_x_1
	 =  happyIn28
		 (OpenTypeKind
	)

happyReduce_49 = happySpecReduce_3 24# happyReduction_49
happyReduction_49 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_2 of { happy_var_2 -> 
	happyIn28
		 (happy_var_2
	)}

happyReduce_50 = happySpecReduce_1 25# happyReduction_50
happyReduction_50 happy_x_1
	 =  case happyOut28 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_51 = happySpecReduce_3 25# happyReduction_51
happyReduction_51 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut28 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (FunKind happy_var_1 happy_var_3
	)}}

happyReduce_52 = happySpecReduce_1 26# happyReduction_52
happyReduction_52 happy_x_1
	 =  case happyOut37 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 (IfaceLcl happy_var_1
	)}

happyReduce_53 = happySpecReduce_3 26# happyReduction_53
happyReduction_53 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut5 happy_x_1 of { happy_var_1 -> 
	case happyOut21 happy_x_3 of { happy_var_3 -> 
	happyIn30
		 (IfaceExt (ExtPkg happy_var_1 happy_var_3)
	)}}

happyReduce_54 = happySpecReduce_1 26# happyReduction_54
happyReduction_54 happy_x_1
	 =  case happyOut35 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 (IfaceLit happy_var_1
	)}

happyReduce_55 = happySpecReduce_3 26# happyReduction_55
happyReduction_55 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut32 happy_x_2 of { happy_var_2 -> 
	happyIn30
		 (happy_var_2
	)}

happyReduce_56 = happySpecReduce_2 27# happyReduction_56
happyReduction_56 happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut30 happy_x_2 of { happy_var_2 -> 
	happyIn31
		 (IfaceApp happy_var_1 happy_var_2
	)}}

happyReduce_57 = happySpecReduce_3 27# happyReduction_57
happyReduction_57 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut14 happy_x_3 of { happy_var_3 -> 
	happyIn31
		 (IfaceApp happy_var_1 (IfaceType happy_var_3)
	)}}

happyReduce_58 = happySpecReduce_1 27# happyReduction_58
happyReduction_58 happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	happyIn31
		 (happy_var_1
	)}

happyReduce_59 = happySpecReduce_1 28# happyReduction_59
happyReduction_59 happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	happyIn32
		 (happy_var_1
	)}

happyReduce_60 = happyReduce 4# 28# happyReduction_60
happyReduction_60 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_2 of { happy_var_2 -> 
	case happyOut32 happy_x_4 of { happy_var_4 -> 
	happyIn32
		 (foldr IfaceLam happy_var_4 happy_var_2
	) `HappyStk` happyRest}}

happyReduce_61 = happyReduce 4# 28# happyReduction_61
happyReduction_61 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut18 happy_x_2 of { happy_var_2 -> 
	case happyOut32 happy_x_4 of { happy_var_4 -> 
	happyIn32
		 (IfaceLet happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_62 = happyReduce 10# 28# happyReduction_62
happyReduction_62 (happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut16 happy_x_3 of { happy_var_3 -> 
	case happyOut30 happy_x_5 of { happy_var_5 -> 
	case happyOut24 happy_x_7 of { happy_var_7 -> 
	case happyOut33 happy_x_9 of { happy_var_9 -> 
	happyIn32
		 (IfaceCase happy_var_5 (fst happy_var_7) happy_var_3 happy_var_9
	) `HappyStk` happyRest}}}}

happyReduce_63 = happySpecReduce_3 28# happyReduction_63
happyReduction_63 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut14 happy_x_2 of { happy_var_2 -> 
	case happyOut32 happy_x_3 of { happy_var_3 -> 
	happyIn32
		 (IfaceNote (IfaceCoerce happy_var_2) happy_var_3
	)}}

happyReduce_64 = happySpecReduce_3 28# happyReduction_64
happyReduction_64 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TKstring happy_var_2) -> 
	case happyOut32 happy_x_3 of { happy_var_3 -> 
	happyIn32
		 (case happy_var_2 of
	       --"SCC"      -> IfaceNote (IfaceSCC "scc") happy_var_3
	       "InlineCall" -> IfaceNote IfaceInlineCall happy_var_3
	       "InlineMe"   -> IfaceNote IfaceInlineMe happy_var_3
	)}}

happyReduce_65 = happySpecReduce_3 28# happyReduction_65
happyReduction_65 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TKstring happy_var_2) -> 
	case happyOut14 happy_x_3 of { happy_var_3 -> 
	happyIn32
		 (IfaceFCall (ForeignCall.CCall 
                                                    (CCallSpec (StaticTarget (mkFastString happy_var_2)) 
                                                               CCallConv (PlaySafe False))) 
                                                 happy_var_3
	)}}

happyReduce_66 = happySpecReduce_1 29# happyReduction_66
happyReduction_66 happy_x_1
	 =  case happyOut34 happy_x_1 of { happy_var_1 -> 
	happyIn33
		 ([happy_var_1]
	)}

happyReduce_67 = happySpecReduce_3 29# happyReduction_67
happyReduction_67 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut34 happy_x_1 of { happy_var_1 -> 
	case happyOut33 happy_x_3 of { happy_var_3 -> 
	happyIn33
		 (happy_var_1:happy_var_3
	)}}

happyReduce_68 = happyReduce 6# 30# happyReduction_68
happyReduction_68 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut39 happy_x_3 of { happy_var_3 -> 
	case happyOut23 happy_x_4 of { happy_var_4 -> 
	case happyOut32 happy_x_6 of { happy_var_6 -> 
	happyIn34
		 ((IfaceDataAlt happy_var_3, map ifaceBndrName happy_var_4, happy_var_6)
	) `HappyStk` happyRest}}}

happyReduce_69 = happySpecReduce_3 30# happyReduction_69
happyReduction_69 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut35 happy_x_1 of { happy_var_1 -> 
	case happyOut32 happy_x_3 of { happy_var_3 -> 
	happyIn34
		 ((IfaceLitAlt happy_var_1, [], happy_var_3)
	)}}

happyReduce_70 = happySpecReduce_3 30# happyReduction_70
happyReduction_70 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut32 happy_x_3 of { happy_var_3 -> 
	happyIn34
		 ((IfaceDefault, [], happy_var_3)
	)}

happyReduce_71 = happyReduce 5# 31# happyReduction_71
happyReduction_71 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TKinteger happy_var_2) -> 
	case happyOut14 happy_x_4 of { happy_var_4 -> 
	happyIn35
		 (convIntLit happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_72 = happyReduce 5# 31# happyReduction_72
happyReduction_72 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TKrational happy_var_2) -> 
	case happyOut14 happy_x_4 of { happy_var_4 -> 
	happyIn35
		 (convRatLit happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_73 = happyReduce 5# 31# happyReduction_73
happyReduction_73 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TKchar happy_var_2) -> 
	happyIn35
		 (MachChar happy_var_2
	) `HappyStk` happyRest}

happyReduce_74 = happyReduce 5# 31# happyReduction_74
happyReduction_74 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TKstring happy_var_2) -> 
	happyIn35
		 (MachStr (mkFastString happy_var_2)
	) `HappyStk` happyRest}

happyReduce_75 = happySpecReduce_1 32# happyReduction_75
happyReduction_75 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TKname happy_var_1) -> 
	happyIn36
		 (mkSysOcc tvName happy_var_1
	)}

happyReduce_76 = happySpecReduce_1 33# happyReduction_76
happyReduction_76 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TKname happy_var_1) -> 
	happyIn37
		 (mkSysOcc varName happy_var_1
	)}

happyReduce_77 = happySpecReduce_3 34# happyReduction_77
happyReduction_77 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut5 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { (TKcname happy_var_3) -> 
	happyIn38
		 (ExtPkg happy_var_1 (mkSysOcc tcName happy_var_3)
	)}}

happyReduce_78 = happySpecReduce_1 35# happyReduction_78
happyReduction_78 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TKcname happy_var_1) -> 
	happyIn39
		 (mkSysOcc dataName happy_var_1
	)}

happyReduce_79 = happySpecReduce_1 36# happyReduction_79
happyReduction_79 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TKcname happy_var_1) -> 
	happyIn40
		 (mkSysOcc varName happy_var_1
	)}

happyNewToken action sts stk
	= lexer(\tk -> 
	let cont i = happyDoAction i tk action sts stk in
	case tk of {
	TKEOF -> happyDoAction 34# (error "reading EOF!") action sts stk;
	TKmodule -> cont 1#;
	TKdata -> cont 2#;
	TKnewtype -> cont 3#;
	TKforall -> cont 4#;
	TKrec -> cont 5#;
	TKlet -> cont 6#;
	TKin -> cont 7#;
	TKcase -> cont 8#;
	TKof -> cont 9#;
	TKcoerce -> cont 10#;
	TKnote -> cont 11#;
	TKexternal -> cont 12#;
	TKwild -> cont 13#;
	TKoparen -> cont 14#;
	TKcparen -> cont 15#;
	TKobrace -> cont 16#;
	TKcbrace -> cont 17#;
	TKhash -> cont 18#;
	TKeq -> cont 19#;
	TKcoloncolon -> cont 20#;
	TKstar -> cont 21#;
	TKrarrow -> cont 22#;
	TKlambda -> cont 23#;
	TKat -> cont 24#;
	TKdot -> cont 25#;
	TKquestion -> cont 26#;
	TKsemicolon -> cont 27#;
	TKname happy_dollar_dollar -> cont 28#;
	TKcname happy_dollar_dollar -> cont 29#;
	TKinteger happy_dollar_dollar -> cont 30#;
	TKrational happy_dollar_dollar -> cont 31#;
	TKstring happy_dollar_dollar -> cont 32#;
	TKchar happy_dollar_dollar -> cont 33#;
	_ -> happyError'
	})

happyError_ tk = happyError'

happyThen :: () => P a -> (a -> P b) -> P b
happyThen = (thenP)
happyReturn :: () => a -> P a
happyReturn = (returnP)
happyThen1 = happyThen
happyReturn1 :: () => a -> P a
happyReturn1 = happyReturn
happyError' :: () => P a
happyError' = happyError

parseCore = happySomeParser where
  happySomeParser = happyThen (happyParse 0#) (\x -> happyReturn (happyOut4 x))

happySeq = happyDontSeq

ifaceBndrName (IfaceIdBndr (n,_)) = n
ifaceBndrName (IfaceTvBndr (n,_)) = n

convIntLit :: Integer -> IfaceType -> Literal
convIntLit i (IfaceTyConApp tc [])
  | tc `eqTc` intPrimTyCon  = MachInt  i  
  | tc `eqTc` wordPrimTyCon = MachWord i
  | tc `eqTc` charPrimTyCon = MachChar (chr (fromInteger i))
  | tc `eqTc` addrPrimTyCon && i == 0 = MachNullAddr
convIntLit i aty
  = pprPanic "Unknown integer literal type" (ppr aty)

convRatLit :: Rational -> IfaceType -> Literal
convRatLit r (IfaceTyConApp tc [])
  | tc `eqTc` floatPrimTyCon  = MachFloat  r
  | tc `eqTc` doublePrimTyCon = MachDouble r
convRatLit i aty
  = pprPanic "Unknown rational literal type" (ppr aty)

eqTc :: IfaceTyCon -> TyCon -> Bool   -- Ugh!
eqTc (IfaceTc (ExtPkg mod occ)) tycon
  = mod == nameModule nm && occ == nameOccName nm
  where
    nm = tyConName tycon

-- Tiresomely, we have to generate both HsTypes (in type/class decls) 
-- and IfaceTypes (in Core expressions).  So we parse them as IfaceTypes,
-- and convert to HsTypes here.  But the IfaceTypes we can see here
-- are very limited (see the productions for 'ty', so the translation
-- isn't hard
toHsType :: IfaceType -> LHsType RdrName
toHsType (IfaceTyVar v)        		 = noLoc $ HsTyVar (mkRdrUnqual v)
toHsType (IfaceAppTy t1 t2)    		 = noLoc $ HsAppTy (toHsType t1) (toHsType t2)
toHsType (IfaceFunTy t1 t2)    		 = noLoc $ HsFunTy (toHsType t1) (toHsType t2)
toHsType (IfaceTyConApp (IfaceTc tc) ts) = foldl mkHsAppTy (noLoc $ HsTyVar (ifaceExtRdrName tc)) (map toHsType ts) 
toHsType (IfaceForAllTy tv t)            = add_forall (toHsTvBndr tv) (toHsType t)

toHsTvBndr :: IfaceTvBndr -> LHsTyVarBndr RdrName
toHsTvBndr (tv,k) = noLoc $ KindedTyVar (mkRdrUnqual tv) k

ifaceExtRdrName :: IfaceExtName -> RdrName
ifaceExtRdrName (ExtPkg mod occ) = mkOrig mod occ
ifaceExtRdrName other = pprPanic "ParserCore.ifaceExtRdrName" (ppr other)

add_forall tv (L _ (HsForAllTy exp tvs cxt t))
  = noLoc $ HsForAllTy exp (tv:tvs) cxt t
add_forall tv t
  = noLoc $ HsForAllTy Explicit [tv] (noLoc []) t
  
happyError :: P a 
happyError s l = failP (show l ++ ": Parse error\n") (take 100 s) l
{-# LINE 1 "GenericTemplate.hs" #-}
-- $Id$













{-# LINE 27 "GenericTemplate.hs" #-}



data Happy_IntList = HappyCons Int# Happy_IntList






































infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	(happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
	= {- nothing -}


	  case action of
		0#		  -> {- nothing -}
				     happyFail i tk st
		-1# 	  -> {- nothing -}
				     happyAccept i tk st
		n | (n <# (0# :: Int#)) -> {- nothing -}

				     (happyReduceArr ! rule) i tk st
				     where rule = (I# ((negateInt# ((n +# (1# :: Int#))))))
		n		  -> {- nothing -}


				     happyShift new_state i tk st
				     where new_state = (n -# (1# :: Int#))
   where off    = indexShortOffAddr happyActOffsets st
	 off_i  = (off +# i)
	 check  = if (off_i >=# (0# :: Int#))
			then (indexShortOffAddr happyCheck off_i ==#  i)
			else False
 	 action | check     = indexShortOffAddr happyTable off_i
		| otherwise = indexShortOffAddr happyDefActions st











indexShortOffAddr (HappyA# arr) off =
#if __GLASGOW_HASKELL__ > 500
	narrow16Int# i
#elif __GLASGOW_HASKELL__ == 500
	intToInt16# i
#else
	(i `iShiftL#` 16#) `iShiftRA#` 16#
#endif
  where
#if __GLASGOW_HASKELL__ >= 503
	i = word2Int# ((high `uncheckedShiftL#` 8#) `or#` low)
#else
	i = word2Int# ((high `shiftL#` 8#) `or#` low)
#endif
	high = int2Word# (ord# (indexCharOffAddr# arr (off' +# 1#)))
	low  = int2Word# (ord# (indexCharOffAddr# arr off'))
	off' = off *# 2#





data HappyAddr = HappyA# Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 169 "GenericTemplate.hs" #-}


-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case unsafeCoerce# x of { (I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k -# (1# :: Int#)) sts of
	 sts1@((HappyCons (st1@(action)) (_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@((HappyCons (st1@(action)) (_))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n -# (1# :: Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n -# (1#::Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off    = indexShortOffAddr happyGotoOffsets st
	 off_i  = (off +# nt)
 	 new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail  0# tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
	happyDoAction 0# tk action sts ( (unsafeCoerce# (I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
